## memtest86+ 1.15

=== Makefile ===
# Makefile for MemTest-86
#
# Author:		Chris Brady
# Created:		January 1, 1996

#
# Path for the floppy disk device
#
FDISK=/dev/fd0

CC=gcc
#
# gcc compiler options, these settings should suffice
#
CCFLAGS=-Wall -march=i486 -Os -fomit-frame-pointer -fno-builtin -ffreestanding

AS=as

OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o

all: memtest.bin memtest

reloc.o: reloc.c
	$(CC) -c -march=i486 -fPIC -Wall -g -O2 -fno-strict-aliasing reloc.c

test.o: test.c test.h defs.h config.h
	$(CC) -c $(CCFLAGS) test.c

main.o: main.c test.h defs.h
	$(CC) -c $(CCFLAGS) -fPIC main.c

init.o: init.c test.h defs.h io.h config.h controller.h pci.h
	$(CC) -c $(CCFLAGS) -fPIC init.c

linuxbios.o: linuxbios.c test.h linuxbios_tables.h defs.h config.h
	$(CC) -c $(CCFLAGS) -fPIC linuxbios.c

memsize.o: memsize.c test.h defs.h config.h
	$(CC) -c $(CCFLAGS) -fPIC memsize.c

lib.o: lib.c test.h defs.h io.h screen_buffer.h serial.h config.h
	$(CC) -c $(CCFLAGS) -fPIC lib.c

screen_buffer.o: screen_buffer.c screen_buffer.h test.h config.h
	$(CC) -c $(CCFLAGS) -fPIC screen_buffer.c

patn.o: patn.c
	$(CC) -c $(CCFLAGS) -fPIC patn.c

config.o: config.c test.h controller.h screen_buffer.h
	$(CC) -c $(CCFLAGS) -fPIC config.c

pci.o: pci.c pci.h io.h
	$(CC) -c $(CCFLAGS) -fPIC pci.c

controller.o: controller.c defs.h config.h test.h pci.h controller.h
	$(CC) -c $(CCFLAGS) -fPIC controller.c

controller.s: controller.c defs.h config.h test.h pci.h controller.h
	$(CC) -S $(CCFLAGS) -fPIC controller.c

head.s: head.S
	$(CC) -E -traditional $< -o $@

head.o: head.s
	$(AS) -o $@ $<

makedefs: makedefs.c defs.h
	 $(CC) $(CCFLAGS) makedefs.c -o $@

# Link it statically once so I know I don't have undefined
# symbols and then link it dynamically so I have full
# relocation information
memtest_shared: $(OBJS) memtest_shared.lds Makefile
	$(LD) --warn-constructors --warn-common -static -T memtest_shared.lds -o $@ $(OBJS) && \
	$(LD) -shared -Bsymbolic -T memtest_shared.lds -o $@ $(OBJS)

memtest_shared.bin: memtest_shared
	objcopy -O binary $< memtest_shared.bin

memtest: memtest_shared.bin memtest.lds
	$(LD) -s -T memtest.lds -b binary memtest_shared.bin -o $@

bootsect.s: bootsect.S defs.h
	$(CC) -E -traditional $< -o $@

bootsect.o: bootsect.s
	$(AS) -o $@ $<

bootsect: bootsect.o
	$(LD) -Ttext 0x00 -s --oformat binary -e _main --just-symbols=memtest_shared.o -o $@ $<

setup.s: setup.S config.h defs.h
	$(CC) -E -traditional $< -o $@

setup.o: setup.s
	$(AS) -o $@ $<


memtest.bin: memtest_shared.bin bootsect.o setup.o memtest.bin.lds
	$(LD) -T memtest.bin.lds bootsect.o setup.o -b binary memtest_shared.bin -o memtest.bin

clean:
	rm -f *.o *.s memtest.bin bootsect setup low_mapfile high_mapfile \
		memtest memtest.out makedefs defs.lds memtest_shared memtest_shared.bin

wormkill: 
	rm -f *~

install: all
	dd <memtest.bin >$(FDISK) bs=8192

install-bin:
	dd <precomp.bin >$(FDISK) bs=8192

## memtest86+ 1.30

=== Makefile ===
--- 
+++ 
@@ -12,16 +12,16 @@
 #
 # gcc compiler options, these settings should suffice
 #
-CCFLAGS=-Wall -march=i486 -Os -fomit-frame-pointer -fno-builtin -ffreestanding
+CCFLAGS=-Wall -m32 -march=i486 -Os -fomit-frame-pointer -fno-builtin -ffreestanding
 
-AS=as
+AS=as -32
 
-OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o
+OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o extra.o
 
 all: memtest.bin memtest
 
 reloc.o: reloc.c
-	$(CC) -c -march=i486 -fPIC -Wall -g -O2 -fno-strict-aliasing reloc.c
+	$(CC) -c -m32 -march=i486 -fPIC -Wall -g -O2 -fno-strict-aliasing reloc.c
 
 test.o: test.c test.h defs.h config.h
 	$(CC) -c $(CCFLAGS) test.c
@@ -56,17 +56,21 @@
 controller.o: controller.c defs.h config.h test.h pci.h controller.h
 	$(CC) -c $(CCFLAGS) -fPIC controller.c
 
+extra.o: config.c test.h screen_buffer.h extra.h
+	$(CC) -c $(CCFLAGS) -fPIC extra.c
+
 controller.s: controller.c defs.h config.h test.h pci.h controller.h
 	$(CC) -S $(CCFLAGS) -fPIC controller.c
 
 head.s: head.S
-	$(CC) -E -traditional $< -o $@
+	$(CC) -E -m32 -traditional $< -o $@
 
 head.o: head.s
 	$(AS) -o $@ $<
 
 makedefs: makedefs.c defs.h
-	 $(CC) $(CCFLAGS) makedefs.c -o $@
+	$(CC) $(CCFLAGS) makedefs.c -o $@
+
 
 # Link it statically once so I know I don't have undefined
 # symbols and then link it dynamically so I have full

## memtest86+ 1.65

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 AS=as -32
 
-OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o extra.o
+OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o extra.o random.o 
 
 all: memtest.bin memtest
 
@@ -43,6 +43,9 @@
 
 screen_buffer.o: screen_buffer.c screen_buffer.h test.h config.h
 	$(CC) -c $(CCFLAGS) -fPIC screen_buffer.c
+
+random.o: random.c
+	$(CC) -c $(CCFLAGS) -fPIC random.c
 
 patn.o: patn.c
 	$(CC) -c $(CCFLAGS) -fPIC patn.c

## memtest86+ 1.70

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 AS=as -32
 
-OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o extra.o random.o 
+OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o config.o linuxbios.o memsize.o pci.o controller.o extra.o random.o dmi.o
 
 all: memtest.bin memtest
 
@@ -70,6 +70,8 @@
 
 head.o: head.s
 	$(AS) -o $@ $<
+dmi.o:	dmi.c test.h
+	 $(CC) -c $(CCFLAGS) -fPIC dmi.c
 
 makedefs: makedefs.c defs.h
 	$(CC) $(CCFLAGS) makedefs.c -o $@

## memtest86+ 2.01

=== Makefile ===
# Makefile for MemTest86+
#
# Author:		Chris Brady
# Created:		January 1, 1996

#
# Path for the floppy disk device
#
FDISK=/dev/fd0

AS=as -32
CC=gcc

CFLAGS=-Wall -march=i486 -m32 -Os -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC

OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o \
      config.o linuxbios.o memsize.o pci.o controller.o random.o extra.o \
      spd.o error.o dmi.o

all: memtest.bin memtest

# Link it statically once so I know I don't have undefined
# symbols and then link it dynamically so I have full
# relocation information
memtest_shared: $(OBJS) memtest_shared.lds Makefile
	$(LD) --warn-constructors --warn-common -static -T memtest_shared.lds \
	-o $@ $(OBJS) && \
	$(LD) -shared -Bsymbolic -T memtest_shared.lds -o $@ $(OBJS)

memtest_shared.bin: memtest_shared
	objcopy -O binary $< memtest_shared.bin

memtest: memtest_shared.bin memtest.lds
	$(LD) -s -T memtest.lds -b binary memtest_shared.bin -o $@

head.s: head.S config.h defs.h test.h
	$(CC) -E -traditional $< -o $@

bootsect.s: bootsect.S config.h defs.h
	$(CC) -E -traditional $< -o $@

setup.s: setup.S config.h defs.h
	$(CC) -E -traditional $< -o $@

memtest.bin: memtest_shared.bin bootsect.o setup.o memtest.bin.lds
	$(LD) -T memtest.bin.lds bootsect.o setup.o -b binary \
	memtest_shared.bin -o memtest.bin

reloc.o: reloc.c
	$(CC) -c $(CFLAGS) -fno-strict-aliasing reloc.c

test.o: test.c
	$(CC) -c -Wall -march=i486 -m32 -Os -fomit-frame-pointer -fno-builtin -ffreestanding test.c

clean:
	rm -f *.o *.s *.iso memtest.bin memtest memtest_shared memtest_shared.bin

iso:
	make all
	./makeiso.sh
	rm -f *.o *.s memtest.bin memtest memtest_shared memtest_shared.bin

install: all
	dd <memtest.bin >$(FDISK) bs=8192

install-precomp:
	dd <precomp.bin >$(FDISK) bs=8192

## memtest86+ 2.11

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 AS=as -32
 CC=gcc
 
-CFLAGS=-Wall -march=i486 -m32 -Os -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC
+CFLAGS= -Wall -march=i486 -m32 -Os -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC
 
 OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o \
       config.o linuxbios.o memsize.o pci.o controller.o random.o extra.o \
@@ -65,3 +65,7 @@
 
 install-precomp:
 	dd <precomp.bin >$(FDISK) bs=8192
+	
+dos: all
+	cat mt86+_loader memtest.bin > memtest.exe
+

## memtest86+ 4.00

=== Makefile ===
--- 
+++ 
@@ -11,11 +11,11 @@
 AS=as -32
 CC=gcc
 
-CFLAGS= -Wall -march=i486 -m32 -Os -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC
+CFLAGS= -Wall -march=i486 -m32 -O2 -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC
 
 OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o \
-      config.o linuxbios.o memsize.o pci.o controller.o random.o extra.o \
-      spd.o error.o dmi.o
+      config.o linuxbios.o memsize.o pci.o controller.o random.o spd.o \
+      error.o dmi.o cpuid.o
 
 all: memtest.bin memtest
 
@@ -55,6 +55,9 @@
 clean:
 	rm -f *.o *.s *.iso memtest.bin memtest memtest_shared memtest_shared.bin
 
+asm:
+	@./makedos.sh
+
 iso:
 	make all
 	./makeiso.sh

## memtest86+ 4.10

=== Makefile ===
--- 
+++ 
@@ -11,7 +11,7 @@
 AS=as -32
 CC=gcc
 
-CFLAGS= -Wall -march=i486 -m32 -O2 -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC
+CFLAGS= -Wall -march=i486 -m32 -O2 -fomit-frame-pointer -fno-builtin -ffreestanding -fPIC -fno-stack-protector
 
 OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o \
       config.o linuxbios.o memsize.o pci.o controller.o random.o spd.o \

## memtest86+ 5.01

=== Makefile ===
# Makefile for MemTest86+
#
# Author:		Chris Brady
# Created:		January 1, 1996


#
# Path for the floppy disk device
#
FDISK=/dev/fd0

AS=as -32
CC=gcc

CFLAGS= -Wall -march=i486 -m32 -O1 -fomit-frame-pointer -fno-builtin \
	-ffreestanding -fPIC $(SMP_FL) -fno-stack-protector 
	
OBJS= head.o reloc.o main.o test.o init.o lib.o patn.o screen_buffer.o \
      config.o cpuid.o linuxbios.o pci.o memsize.o spd.o error.o dmi.o controller.o \
      smp.o vmem.o random.o
      

all: clean memtest.bin memtest 
		 scp memtest.bin root@192.168.0.12:/srv/tftp/mt86plus

# Link it statically once so I know I don't have undefined
# symbols and then link it dynamically so I have full
# relocation information
memtest_shared: $(OBJS) memtest_shared.lds Makefile
	$(LD) --warn-constructors --warn-common -static -T memtest_shared.lds \
	 -o $@ $(OBJS) && \
	$(LD) -shared -Bsymbolic -T memtest_shared.lds -o $@ $(OBJS)

memtest_shared.bin: memtest_shared
	objcopy -O binary $< memtest_shared.bin

memtest: memtest_shared.bin memtest.lds
	$(LD) -s -T memtest.lds -b binary memtest_shared.bin -o $@

head.s: head.S config.h defs.h test.h
	$(CC) -E -traditional $< -o $@

bootsect.s: bootsect.S config.h defs.h
	$(CC) -E -traditional $< -o $@

setup.s: setup.S config.h defs.h
	$(CC) -E -traditional $< -o $@

memtest.bin: memtest_shared.bin bootsect.o setup.o memtest.bin.lds
	$(LD) -T memtest.bin.lds bootsect.o setup.o -b binary \
	memtest_shared.bin -o memtest.bin

reloc.o: reloc.c
	$(CC) -c $(CFLAGS) -fno-strict-aliasing reloc.c

test.o: test.c
	$(CC) -c -Wall -march=i486 -m32 -O0 -fomit-frame-pointer -fno-builtin -ffreestanding test.c

random.o: random.c
	$(CC) -c -Wall -march=i486 -m32 -O3 -fomit-frame-pointer -fno-builtin -ffreestanding random.c
	
# rule for build number generation  
build_number:
	sh make_buildnum.sh  

clean:
	rm -f *.o *.s *.iso memtest.bin memtest memtest_shared \
		memtest_shared.bin memtest.iso

iso:
	make all
	./makeiso.sh

install: all
	dd <memtest.bin >$(FDISK) bs=8192

install-precomp:
	dd <precomp.bin >$(FDISK) bs=8192
	
dos: all
	cat mt86+_loader memtest.bin > memtest.exe

=== debian/changelog ===
memtest86+ (5.01-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix passing serial options on the command line
    (Closes: #695873): serial-console-fix.patch

 -- Louis-Philippe Véronneau <pollo@debian.org>  Thu, 15 Aug 2019 13:49:09 -0400

memtest86+ (5.01-3) unstable; urgency=medium

  * Build with -fgnu89-inline for GCC 5 (Matthias Klose, Closes: #778001)

 -- Yann Dirson <dirson@debian.org>  Thu, 25 Jun 2015 19:14:21 +0200

memtest86+ (5.01-2) unstable; urgency=medium

  * Build -O0 to workaround what is apparently a gcc 4.9 optimisation bug,
    and use "static" the __in and __out macros to allow compilation to
    proceed under this condition (as done in other distros, including
    Mageia, closes: #753627): memtest86+-5.01-O0.patch.
  * Fix PCI bus scanning on Nehalem architectures (patch from the Mageia
    package): memtest86+-5.01-array-size.patch.
  * Bumped Standards-Version to 3.9.5, no change.

 -- Yann Dirson <dirson@debian.org>  Wed, 10 Sep 2014 21:58:11 +0200

memtest86+ (5.01-1) unstable; urgency=medium

  * Switch to source format 3.0 (quilt).
  * New upstream release (Closes: #727638).
    * Drop makeiso.sh fix for genisoimage, integrated upstream.
    * Refresh multiboot patch, but do not include additional fix for
      #568176 yet (needs more work).
    * Call build target explicitely, since the default target now attempts
      an scp.
  * Include chineses translations for package descriptions (Anthony Wong
    <ypwong@gmail.com>, Closes: #741432)
  * Only run update-grub in the postrm on remove/purge (Luke Faraone /
    Ubuntu, Closes: #587340)
  * Remove leading ./ in lintian-override paths so they get recognized again.

 -- Yann Dirson <dirson@debian.org>  Sat, 28 Jun 2014 17:02:10 +0200

memtest86+ (4.20-1) unstable; urgency=low

  * New upstream release.
  * Acknowledge NMU.
  * Adjust makeiso.sh to call genisoimage.
  * Produce a memtest86+.iso using makeiso.sh and ship it in
    /usr/lib/memtest86+/.  Add build-dep on genisoimage.
  * Drop the old make-memtest86+-boot-floppy script, which was dependant
    on grub-legacy, and whose usefulness is much lower now that we ship an
    iso.  Closes: #591578.
  * Advertise multiboot as experimental in README.Debian.

 -- Yann Dirson <dirson@debian.org>  Sat, 19 Mar 2011 23:40:07 +0100

memtest86+ (4.10-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix pending l10n issues. Debconf translations:
    - Czech (Michal Simunek).  Closes: #589811
    - Italian (Vincenzo Campanella).  Closes: #600219

 -- Christian Perrier <bubulle@debian.org>  Tue, 19 Oct 2010 07:24:39 +0200

memtest86+ (4.10-1) unstable; urgency=low

  * The "not yet source format 3.0" release.
  * New upstream release (Closes: #586727).
    * supports 64 e820 lines (Closes: #567165).
  * Acknowledge NMUs (Closes: #565642).
  * Don't emit grub2 menu items if /boot is on a loop-mounted device
    (Ubuntu, Closes: 574788).
  * Cache results of prepare_grub_to_access_device to speed up update-grub
    runs (Ubuntu, Closes: #570987).
  * Fix typo in package description (Robert Tomsick, Closes: #580147).
  * Suggest "grub-pc | grub-legacy" instead of old "grub2 | grub" (Closes:
    #568624).
  * Include es.po for po-debconf (Francisco Javier Cuadrado, Closes:
    #580953).
  * Provide boot entries for non-multiboot image, and tag the multiboot
    ones as experimental (mitigates #570499).
  * Install elf image again (was silently dropped in -2.2).
  * Bumped Standards-Version to 3.8.4, no change.

 -- Yann Dirson <dirson@debian.org>  Sun, 27 Jun 2010 15:16:43 +0200

memtest86+ (4.00-2.3) unstable; urgency=low

  * Non-maintainer upload.
  * Check for grub.cfg in postinst. Closes: #550337

 -- Michal Suchanek <hramrach@centrum.cz>  Fri, 04 Jun 2010 13:50:53 +0200

memtest86+ (4.00-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Build an image with Multiboot support.  (Closes: #250864)
  * Update de.po, fr.po, ja.po, pt.po, ru.po and sv.po.
    (Closes: #563019, #563288, #564291, #564430, #564470, #565169)
  * Fix in copyright line in debian/copyright to make lintian happy.

 -- Robert Millan <rmh.debian@aybabtu.com>  Sun, 17 Jan 2010 17:06:16 +0100

memtest86+ (4.00-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Replace manual propt with debconf (Closes: #553292).
  * Fix ".: 4: Can't open /usr/lib/grub/grub-mkconfig_lib" by checking
    both grub files and also changing the linux/linux16 grub command based
    on which version we find (Closes: #550096)
  * Update suggests to a recent version of grub2
  * Add a lintian override for statically-linked-binary (which is expected)

 -- Iustin Pop <iusty@k1024.org>  Sun, 06 Dec 2009 12:20:39 +0100

memtest86+ (4.00-2) unstable; urgency=low

  * Fix wrong integration of grub2 patch (Closes: #549125).

 -- Yann Dirson <dirson@debian.org>  Thu, 01 Oct 2009 21:05:36 +0200

memtest86+ (4.00-1) unstable; urgency=low

  * New upstream release (Closes: #548033).
  * Dropped obsolete patches for old gcc-4.3 bugs (works fine now), and
    for opteron (support for builtin memory controller was redone).
  * Update grub2 support file to use "linux16" command and use
    grub-mkconfig_lib instead of old update-grub_lib (Avi Rozen,
    Closes: #539907, #522345).
  * Update grub2 support file for systems where /boot is on a separate
    partition (Vasilis Vasaitis, Closes: #540572).

 -- Yann Dirson <dirson@debian.org>  Tue, 29 Sep 2009 23:40:15 +0200

memtest86+ (2.11-3) unstable; urgency=low

  * Upload to squeeze.
  * Adjust test condition on which to run update-grub2 in postinst (Robert
    Millan, Closes: #448771).
  * Parametrize debian/rules for easier sync with package memtest.
  * Added a note in extended description that memtest86 is still
    being worked on.
  * Otherwise sync minor changes with memtest86 3.5-1 packaging.
  * Provide link to GPL-2 instead of just GPL in copyright file (lintian).
  * Run lilo from postinst without explicit path (lintian).


=== debian/control ===
Source: memtest86+
Section: misc
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>> 5.0.0), dh-buildinfo, gcc-multilib [amd64 kfreebsd-amd64],
 po-debconf, genisoimage
Homepage: http://www.memtest.org/
Standards-Version: 3.9.5

Package: memtest86+
Architecture: i386 amd64 kfreebsd-i386 kfreebsd-amd64 lpia hurd-i386
Depends: ${misc:Depends}
Suggests: hwtools, memtester, kernel-patch-badram, memtest86, grub-pc | grub-legacy, mtools
Description: thorough real-mode memory tester
 Memtest86+ scans your RAM for errors.
 .
 This tester runs independently of any OS - it is run at computer
 boot-up, so that it can test *all* of your memory.  You may want to
 look at `memtester', which allows to test your memory within Linux,
 but this one won't be able to test your whole RAM.
 .
 It can output a list of bad RAM regions usable by the BadRAM kernel
 patch, so that you can still use your old RAM with one or two bad bits.
 .
 Memtest86+ is based on memtest86 3.0, and adds support for recent
 hardware, as well as a number of general-purpose improvements,
 including many patches to memtest86 available from various sources.
 .
 Both memtest86 and memtest86+ are being worked on in parallel.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

PACKAGE=memtest86+

build: build-stamp
build-stamp:
	dh_testdir

# Different kernels, ABIs, ld defaults, see #338603
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	sed -i -e 's/"elf32-i386"/"elf32-i386-freebsd"/' memtest.lds memtest_shared.lds
endif

	$(MAKE) memtest.bin memtest
	./makeiso.sh
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	[ ! -f Makefile ] || $(MAKE) clean

	# make sure PO files are always up-to-date
	debconf-updatepo

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	install -d debian/$(PACKAGE)/usr/bin
	install -D -m644 memtest.bin debian/$(PACKAGE)/boot/$(PACKAGE).bin
	install -D -m644 memtest debian/$(PACKAGE)/usr/lib/$(PACKAGE)/$(PACKAGE).elf
	install -D -m644 mt*.iso debian/$(PACKAGE)/usr/lib/$(PACKAGE)/$(PACKAGE).iso
	install -D -m644 -s memtest_shared debian/$(PACKAGE)/boot/$(PACKAGE)_multiboot.bin
	install -D -m755 debian/grub debian/$(PACKAGE)/etc/grub.d/20_$(PACKAGE)
	#install the lintian override
	install -d debian/$(PACKAGE)/usr/share/lintian/overrides
	install -m644 debian/lintian-overrides \
		debian/$(PACKAGE)/usr/share/lintian/overrides/$(PACKAGE)

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs README
	dh_buildinfo
	dh_installexamples debian/lilo.conf debian/grub-menu.lst
	dh_installchangelogs changelog
#	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
#	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure

## memtest86+ 5.31~beta

=== debian/changelog ===
memtest86+ (5.31~beta-0.1~mx19+1) mx; urgency=medium

  * New upstream beta version.
  * Drop patches, fixed upstream.
  * Bump to debhelper 10 compat.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 27 May 2020 15:10:51 -0700

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,13 @@
 Source: memtest86+
 Section: misc
 Priority: optional
-Maintainer: Yann Dirson <dirson@debian.org>
-Build-Depends: debhelper (>> 5.0.0), dh-buildinfo, gcc-multilib [amd64 kfreebsd-amd64],
- po-debconf, genisoimage
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Yann Dirson <dirson@debian.org>
+Build-Depends: debhelper (>= 10),
+               dh-buildinfo,
+               gcc-multilib [amd64 kfreebsd-amd64],
+               po-debconf,
+               genisoimage
 Homepage: http://www.memtest.org/
 Standards-Version: 3.9.5

## memtest86+ 5.31b+dfsg

=== debian/changelog ===
memtest86+ (5.31b+dfsg-4) unstable; urgency=medium

  [ Fabio Fantoni ]
  * New maintainer (Closes: #969191)
  * another changes to makeiso.sh to make the build reproducible:
    - add -uid and -gid to 0 to xorriso options
    - replaced "echo -e" with printf
  * d/postinst: don't run update-grub if in a container
  * d/control: remove mention of lpia arch

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Bump debhelper from old 12 to 13.
  * Update renamed lintian tag names in lintian overrides.

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Sun, 06 Feb 2022 21:35:43 +0100

memtest86+ (5.31b+dfsg-3) experimental; urgency=medium

  * QA upload.
  * d/control: replace genisoimage build-dep with xorriso
  * removed d/patches/make-iso-reproducible
  * d/patches/use-xorriso-instead-cdrkit.patch:
    cdrkit is not supported anymore, use xorriso instead
    also aded the modification of date part to make the build
    reproducible (Closes: #982240)
  * use SOURCE_DATE_EPOCH instead of add BUILD_DATE in d/rules
  * d/rules:
    - use dh_auto_build instead of make
    - restore a change for kfreebsd

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Sat, 22 Jan 2022 18:20:23 +0100

memtest86+ (5.31b+dfsg-2) experimental; urgency=medium

  * QA upload.
  * d/patches/dmi-more-ram-slots-and-buffer-overflow-fix.patch:
    prevent crash for buffer overflow in DMI memory and increase
    supported memory devices from 16 to 128 (Closes: #1003906)
    Thanks to Lionel Debroux

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Tue, 18 Jan 2022 18:30:04 +0100

memtest86+ (5.31b+dfsg-1) experimental; urgency=medium

  [ Fabio Fantoni ]
  * QA upload.
  * New upstream version 5.31b (Closes: #989030, #977217)
  * Merge from ubuntu:
    - Use elf version by default that should works on major of system.
    - Drop the multiboot image from the GRUB menu for now, since it's
      experimental and has known problems detecting all memory on some
      systems at the moment.
    - Support localization of GRUB menu entries.
    - Don't present in GRUB menu on EFI systems, since it won't work.
      (Closes: #695246)
    - Close FD 3 when invoking update-grub.
  * Warn that don't support EFI instead of exit silently (LP: 1863940)
  * Don't add grub2 entries if GRUB_DISABLE_MEMTEST=true is present
    in /etc/default/grub (LP: #420967)
  * Make possible disable serial with GRUB_MEMTEST_DISABLE_SERIAL,
    enable multiboot with GRUB_MEMTEST_ENABLE_MULTIBOOT and add
    custom serial parameters with GRUB_MEMTEST_SERIAL_PARAMS
    (Closes: #898636, #612371)
  * Specify on grub2 menu entries when elf and bin are used
  * d/control: Remove hwtools and kernel-patch-badram from suggests.
  * d/copyright: add Upstream-Name, Upstream-Contact and Source fields
  * Bumped Standards-Version to 4.6.0
  * d/patches:
    - update multiboot patch from coreboot patch based on the one of
      Vladimir Serbinenko and refreshed for 5.31b (Closes: #568176)
    - refresh memtest86+-5.01-O0.patch
    - disable memtest86+-5.01-array-size.patch and gcc-5 as seems not
      needed with newer upstream version
    - refresh serial-console-fix.patch
    - add test-random-cflags.patch: use CFLAGS with random.o for
      maintain flags like -fno-stack-protector
    - add fix-gcc8-freeze-crash.patch: runtime fix for gcc>=8
      freeze/crash
    - add discard-note_gnu_property.patch: discards the
      ".note.gnu.property" section that causes crash in some cases

  [ Jérémy Bobbio ]
  * Make the package build reproducibly:
    - Add a patch to make ISO image reproducible.
    - Set the build date to the latest debian/changelog entry in
      debian/rules. (Closes: #783515)

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Sun, 09 Jan 2022 21:41:58 +0100

memtest86+ (5.01-4) unstable; urgency=medium

  [ Fabio Fantoni ]
  * QA upload.
  * switch package to use dh and bump compat to 12
    (Closes: #999226, #965720)
  * update debian/watch

  [ Yann Dirson ]
  * Add Vcs-* fields for salsa repo.
  * Add Dutch translation (Closes: #765362)
  * Add Brazilian Portuguese translation (Closes: #787752)
  * Remove usage of obsolete dh_buildinfo

 -- Fabio Fantoni <fantonifabio@tiscali.it>  Sun, 19 Dec 2021 13:56:27 +0100

=== debian/control ===
Source: memtest86+
Section: misc
Priority: optional
Maintainer: Fabio Fantoni <fantonifabio@tiscali.it>
Build-Depends:
 debhelper-compat (= 13),
 dh-exec,
 gcc-multilib [amd64 kfreebsd-amd64],
 xorriso,
 po-debconf,
Homepage: https://www.memtest.org/
Vcs-Git: https://salsa.debian.org/debian/memtest86plus.git
Vcs-Browser: https://salsa.debian.org/debian/memtest86plus
Standards-Version: 4.6.0

Package: memtest86+
Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386
Depends: ${misc:Depends}
Suggests:
 grub-pc | grub-legacy,
 memtest86,
 memtester,
 mtools,
Description: thorough real-mode memory tester
 Memtest86+ scans your RAM for errors.
 .
 This tester runs independently of any OS - it is run at computer
 boot-up, so that it can test *all* of your memory.  You may want to
 look at `memtester', which allows to test your memory within Linux,
 but this one won't be able to test your whole RAM.
 .
 It can output a list of bad RAM regions usable by the BadRAM kernel
 patch, so that you can still use your old RAM with one or two bad bits.
 .
 Memtest86+ is based on memtest86 3.0, and adds support for recent
 hardware, as well as a number of general-purpose improvements,
 including many patches to memtest86 available from various sources.
 .
 Both memtest86 and memtest86+ are being worked on in parallel.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

%:
	dh $@

override_dh_clean:
	# make sure PO files are always up-to-date
	debconf-updatepo --skip-pot
	dh_clean

override_dh_strip:
	dh_strip -Xmemtest86+.bin -Xmemtest86+.elf

override_dh_shlibdeps:
	: # disable it

override_dh_auto_test:
	: # disable it

override_dh_auto_install:
	: # disable it

override_dh_auto_build:
	ls debian/po --hide *.pot --hide *.in | sed 's/\.po//g' | xargs -I {} -t sh -c \
	"mkdir -p debian/locale/{}/LC_MESSAGES/ && \
	msgfmt debian/po/{}.po -o debian/locale/{}/LC_MESSAGES/memtest86+.mo"
	# Different kernels, ABIs, ld defaults, see #338603
ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
	sed -i -e 's/"elf32-i386"/"elf32-i386-freebsd"/' memtest.lds memtest_shared.lds
endif
	# make iso do make all and ./makeiso.sh
	dh_auto_build -- iso

override_dh_fixperms:
	dh_fixperms

	chmod 755 $(CURDIR)/debian/memtest86+/etc/grub.d/20_memtest86+
	chmod 644 $(CURDIR)/debian/memtest86+/boot/memtest86+.bin
	chmod 644 $(CURDIR)/debian/memtest86+/boot/memtest86+_multiboot.bin
	chmod 644 $(CURDIR)/debian/memtest86+/boot/memtest86+.elf

override_dh_installdocs:
	dh_installdocs README

override_dh_installexamples:
	dh_installexamples debian/lilo.conf debian/grub-menu.lst

override_dh_installchangelogs:
	dh_installchangelogs changelog

=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg//,repacksuffix=+dfsg, \
  https://www.memtest.org/ download/(.*)/memtest86\+-(?:.*)\.tar\.gz
